# -*- coding: utf-8 -*-

import os
import unittest

import intelmq.lib.test as test
import intelmq.lib.utils as utils
from intelmq.bots.parsers.malwaregroup.parser_ips import \
    MalwareGroupIPsParserBot

with open(os.path.join(os.path.dirname(__file__),
                       'ipaddresses.html')) as handle:
    EXAMPLE_FILE = handle.read()

EXAMPLE_REPORT = {"feed.name": "MalwareGroup",
                  "feed.url": "http://www.malwaregroup.com/ipaddresses",
                  "raw": utils.base64_encode(EXAMPLE_FILE),
                  "__type": "Report",
                  "time.observation": "2015-01-01T00:00:00+00:00",
                  }
EXAMPLE_EVENT = {"feed.name": "MalwareGroup",
                 "feed.url": "http://www.malwaregroup.com/ipaddresses",
                 "__type": "Event",
                 "time.source": "2015-08-01T00:00:00+00:00",
                 "source.ip": "192.0.2.1",
                 "classification.type": "malware",
                 "raw": "PHRkPjxhIGhyZWY9Ii9pcGFkZHJlc3Nlcy9kZXRhaWxzLzE5Mi4wL"
                        "jIuMSI+MTkyLjAuMi4xPC9hPjwvdGQ+IDx0ZD4xPC90ZD4gPHRkPl"
                        "NvbWUgQ291bnRyeTwvdGQ+IDx0ZD4tPC90ZD4gPHRkPjIwMTUtMDg"
                        "tMDE8L3RkPiA8dGQ+MjAxNS0wOC0wMTwvdGQ+PC90cj4=",
                 "time.observation": "2015-01-01T00:00:00+00:00",
                 }


class TestMalwareGroupIPsParserBot(test.BotTestCase, unittest.TestCase):
    """
    A TestCase for a MalwareGroupIPsParserBot.
    """

    @classmethod
    def set_bot(cls):
        cls.bot_reference = MalwareGroupIPsParserBot
        cls.default_input_message = EXAMPLE_REPORT

    def test_event(self):
        """ Test if correct Event has been produced. """
        self.run_bot()
        self.assertMessageEqual(0, EXAMPLE_EVENT)


if __name__ == '__main__':
    unittest.main()
